
#ifdef	VALUE
#error macro VALUE is defined.
#endif
#ifndef	FLAG
#error macro FLAG is not defined.
#endif

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "facet.h"

#define UShort	unsigned short

extern void	Error(char *msg),
		CM_STL(char *path,UShort *flag),
		SurfaceIntegral(size_t No,size_t Nt,
				double *X0,double *Y0,double *Z0,
				double *X1,double *Y1,double *Z1,
				double *X2,double *Y2,double *Z2,
				double *X3,double *Y3,double *Z3,
				double *Gx,double *Gy,double *Gz);

int	main(int argc,char **argv)
{
	size_t	N,n;
	Facet	*F;
	UShort	flag[32768];
	double	DV1,DV2,*X,*Y,*Z,*X1,*Y1,*Z1,*X2,*Y2,*Z2,*X3,*Y3,*Z3,
		xa,ya,za,xb,yb,zb,x,y,z,c,min,max,base,step;

	if (argc!=2 && argc!=4 && argc!=6)
	    Error("usage : stl_dv STL\n"
		  "        stl_dv STL CM_STL STL\n"
		  "        stl_dv STL min. max. CM_STL STL");

	ReadFacet(argv[1],&N,&F);

	if (argc!=2) CM_STL(argv[argc-2],flag);

	if (argc==6)
	    if ((DV1=atof(argv[2])*M_PI/180.0)<0.0 ||
		(DV2=atof(argv[3])*M_PI/180.0)>M_PI || DV1>DV2)
		Error("bad range of deviation of the vertical in degree.");

#define MA(A,M)	(A=(double *)malloc(sizeof(double)*(M)))==NULL

	if (MA(X,N) || MA(Y,N) || MA(Z,N) ||
	    MA(X1,N) || MA(Y1,N) || MA(Z1,N) ||
	    MA(X2,N) || MA(Y2,N) || MA(Z2,N) ||
	    MA(X3,N) || MA(Y3,N) || MA(Z3,N)) Error("memory allocation error.");

	for (n=0; n<N; n++) {
	    X[n]=((X1[n]=F[n].x1)+(X2[n]=F[n].x2)+(X3[n]=F[n].x3))/3.0;
	    Y[n]=((Y1[n]=F[n].y1)+(Y2[n]=F[n].y2)+(Y3[n]=F[n].y3))/3.0;
	    Z[n]=((Z1[n]=F[n].z1)+(Z2[n]=F[n].z2)+(Z3[n]=F[n].z3))/3.0;
	}
	SurfaceIntegral(N,N,X,Y,Z,X1,Y1,Z1,X2,Y2,Z2,X3,Y3,Z3,X,Y,Z);

	for (n=0; n<N; n++) {
	    xa=F[n].x2-F[n].x1; ya=F[n].y2-F[n].y1; za=F[n].z2-F[n].z1;
	    xb=F[n].x3-F[n].x1; yb=F[n].y3-F[n].y1; zb=F[n].z3-F[n].z1;
            c=X[n]*(x=ya*zb-za*yb)+Y[n]*(y=za*xb-xa*zb)+Z[n]*(z=xa*yb-ya*xb);
	    X[n]=atan2(sqrt((X[n]*X[n]+Y[n]*Y[n]+Z[n]*Z[n])*(x*x+y*y+z*z)-c*c),
		       -c);
	    if (n==0)
		min=max=X[0];
	    else
		if (X[n]<min) min=X[n]; else if (X[n]>max) max=X[n];
	}
	if (argc==2)
	    (void)printf("%lf\t%lf\n",min*180.0/M_PI,max*180.0/M_PI);
	else {
	    if (argc==4) {
		DV1=min; DV2=max;
	    }
	    base=DV1; step=(DV2-DV1)/32767.0;
	    for (n=0; n<N; n++)
		F[n].FLAG=flag[(X[n]<=DV1)?0:
			       (X[n]>=DV2)?32767:
			       (UShort)((X[n]-base)/step+0.5)];

	    StoreFacet(argv[argc-1],N,F);
	}
	return 0;
}
