
#ifdef	VALUE
#error macro VALUE is defined.
#endif
#ifndef	FLAG
#error macro FLAG is not defined.
#endif

#include <stdio.h>
#include <stdlib.h>
#include "facet.h"

#define UShort	unsigned short

extern void	Error(char *msg),
		CM_STL(char *path,UShort *flag),
		SurfaceIntegral(size_t No,size_t Nt,
				double *X0,double *Y0,double *Z0,
				double *X1,double *Y1,double *Z1,
				double *X2,double *Y2,double *Z2,
				double *X3,double *Y3,double *Z3,double *P);

int	main(int argc,char **argv)
{
	size_t	N,n;
	Facet	*F;
	UShort	flag[32768];
	double	P1,P2,*X,*Y,*Z,*X1,*Y1,*Z1,*X2,*Y2,*Z2,*X3,*Y3,*Z3,
		V,x,y,z,v,min,max,base,step;

	if (argc!=2 && argc!=4 && argc!=6)
	    Error("usage : stl_np STL\n"
		  "        stl_np STL CM_STL STL\n"
		  "        stl_np STL min. max. CM_STL STL");

	ReadFacet(argv[1],&N,&F);

	if (argc!=2) CM_STL(argv[argc-2],flag);

	if (argc==6)
	    if ((P1=atof(argv[2]))>=
		(P2=atof(argv[3]))) Error("bad range of normalized potential.");

#define MA(A,M)	(A=(double *)malloc(sizeof(double)*(M)))==NULL

	if (MA(X,N+1) || MA(Y,N+1) || MA(Z,N+1) ||
	    MA(X1,N) || MA(Y1,N) || MA(Z1,N) ||
	    MA(X2,N) || MA(Y2,N) || MA(Z2,N) ||
	    MA(X3,N) || MA(Y3,N) || MA(Z3,N)) Error("memory allocation error.");

	V=X[N]=Y[N]=Z[N]=0.0;
	for (n=0; n<N; n++) {
	    X[n]=(x=(X1[n]=F[n].x1)+(X2[n]=F[n].x2)+(X3[n]=F[n].x3))/3.0;
	    Y[n]=(y=(Y1[n]=F[n].y1)+(Y2[n]=F[n].y2)+(Y3[n]=F[n].y3))/3.0;
	    Z[n]=(z=(Z1[n]=F[n].z1)+(Z2[n]=F[n].z2)+(Z3[n]=F[n].z3))/3.0;
	    V+=(v=X1[n]*Y2[n]*Z3[n]+X2[n]*Y3[n]*Z1[n]+X3[n]*Y1[n]*Z2[n]
		 -X3[n]*Y2[n]*Z1[n]-X1[n]*Y3[n]*Z2[n]-X2[n]*Y1[n]*Z3[n]);
	    v/=4.0; X[N]+=(v*x); Y[N]+=(v*y); Z[N]+=(v*z);
	}
	X[N]/=V; Y[N]/=V; Z[N]/=V;

	SurfaceIntegral(N+1,N,X,Y,Z,X1,Y1,Z1,X2,Y2,Z2,X3,Y3,Z3,X);

	min=max=X[0];
	for (n=1; n<N; n++) if (X[n]<min) min=X[n]; else if (X[n]>max) max=X[n];

	if (argc==2)
	    (void)printf("%le\t%lf\t%lf\n",X[N],min/X[N],max/X[N]);
	else {
	    if (argc==4) {
		P1=min; P2=max;
	    }
	    else {
		P1*=X[N]; P2*=X[N];
	    }
	    base=P1; step=(P2-P1)/32767.0;
	    for (n=0; n<N; n++)
		F[n].FLAG=flag[(X[n]<=P1)?0:
			       (X[n]>=P2)?32767:
			       (UShort)((X[n]-base)/step+0.5)];

	    StoreFacet(argv[argc-1],N,F);
	}
	return 0;
}
