
#include <stdio.h>
#include <stdlib.h>
#include "facet.h"

extern void	Error(char *msg),
		SurfaceIntegral(size_t No,size_t Nt,
				double *X0,double *Y0,double *Z0,
				double *X1,double *Y1,double *Z1,
				double *X2,double *Y2,double *Z2,
				double *X3,double *Y3,double *Z3,
				double *P,double *Gx,double *Gy,double *Gz);

int	main(int argc,char **argv)
{
	size_t	N,n;
	Facet	*F;
	double	*X,*Y,*Z,*X1,*Y1,*Z1,*X2,*Y2,*Z2,*X3,*Y3,*Z3,*P,V,x,y,z,v;

	if (argc!=2) Error("usage : stl_pg STL");

	ReadFacet(argv[1],&N,&F);

#define MA(A,M)	(A=(double *)malloc(sizeof(double)*(M)))==NULL

	if (MA(X,N+1) || MA(Y,N+1) || MA(Z,N+1) ||
	    MA(X1,N) || MA(Y1,N) || MA(Z1,N) ||
	    MA(X2,N) || MA(Y2,N) || MA(Z2,N) ||
	    MA(X3,N) || MA(Y3,N) || MA(Z3,N) ||
	    MA(P,N+1)) Error("memory allocation error.");

	V=X[N]=Y[N]=Z[N]=0.0;
	for (n=0; n<N; n++) {
	    X[n]=(x=(X1[n]=F[n].x1)+(X2[n]=F[n].x2)+(X3[n]=F[n].x3))/3.0;
	    Y[n]=(y=(Y1[n]=F[n].y1)+(Y2[n]=F[n].y2)+(Y3[n]=F[n].y3))/3.0;
	    Z[n]=(z=(Z1[n]=F[n].z1)+(Z2[n]=F[n].z2)+(Z3[n]=F[n].z3))/3.0;
	    V+=(v=X1[n]*Y2[n]*Z3[n]+X2[n]*Y3[n]*Z1[n]+X3[n]*Y1[n]*Z2[n]
		 -X3[n]*Y2[n]*Z1[n]-X1[n]*Y3[n]*Z2[n]-X2[n]*Y1[n]*Z3[n]);
	    v/=4.0; X[N]+=(v*x); Y[N]+=(v*y); Z[N]+=(v*z);
	}
	(void)printf("%le\t%le\t%le\t%le\n",V/6.0,X[N]/=V,Y[N]/=V,Z[N]/=V);

	SurfaceIntegral(N+1,N,X,Y,Z,X1,Y1,Z1,X2,Y2,Z2,X3,Y3,Z3,P,X,Y,Z);

	(void)printf("%le\t%le\t%le\t%le\n",P[N],X[N],Y[N],Z[N]);

	for (n=0; n<N; n++)
	    (void)printf("%le\t%le\t%le\t"
			 "%le\t%le\t%le\t"
			 "%le\t%le\t%le\t%le\t%le\t%le\t%le\n",
			 F[n].x1,F[n].y1,F[n].z1,
			 F[n].x2,F[n].y2,F[n].z2,
			 F[n].x3,F[n].y3,F[n].z3,P[n],X[n],Y[n],Z[n]);

	return 0;
}
