
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

extern void	Error(char *msg),
		SurfaceIntegral(size_t No,size_t Nt,
				double *X0,double *Y0,double *Z0,
				double *X1,double *Y1,double *Z1,
				double *X2,double *Y2,double *Z2,
				double *X3,double *Y3,double *Z3,
				double *P,double *Gx,double *Gy,double *Gz);

#define MA(A,M)	(A=(double *)malloc(sizeof(double)*(M)))==NULL
#define RA(A,M)	(A=(double *)realloc(A,sizeof(double)*(M)))==NULL

#define LEN	2048
#define INC	2048

int	main(int argc,char **argv)
{
	FILE		*file;
	char		str[LEN],
			*fnf=" : file not found.",
			*dre="data read error.",
			*mae="memory allocation error.",
			*mrae="memory re-allocation error.";
	unsigned long	V,F,i,v1,v2,v3,N;
	double		*X,*Y,*Z,*X1,*Y1,*Z1,*X2,*Y2,*Z2,*X3,*Y3,*Z3,
			v,x,y,z,x1,y1,z1,x2,y2,z2,x3,y3,z3,w,*P,p1,p2;

	if (argc!=2 && argc!=3) Error("usage : vf_g vf.txt {point.txt}");

	if (argv[1][0]=='-')
	    file=stdin;
	else
	    if ((file=fopen(argv[1],"r"))==NULL) {
		(void)fputs(argv[1],stderr); Error(fnf);
	    }

	if (fgets(str,LEN,file)==NULL || str[strlen(str)-1]!='\n' ||
	    sscanf(str,"%lu %lu",&V,&F)!=2 ||
	    V==0 || F==0) Error("bad data number.");

	if (MA(X,V) || MA(Y,V) || MA(Z,V) ||
	    MA(X1,F) || MA(Y1,F) || MA(Z1,F) ||
	    MA(X2,F) || MA(Y2,F) || MA(Z2,F) ||
	    MA(X3,F) || MA(Y3,F) || MA(Z3,F)) Error(mae);

	for (i=0; i<V; i++)
	    if (fgets(str,LEN,file)==NULL || str[strlen(str)-1]!='\n' ||
		sscanf(str,"%lf %lf %lf",X+i,Y+i,Z+i)!=3) Error(dre);

	v=x=y=z=0.0;
	for (i=0; i<F; i++) {
	    if (fgets(str,LEN,file)==NULL || str[strlen(str)-1]!='\n' ||
		sscanf(str,"%lu %lu %lu",&v1,&v2,&v3)!=3 ||
		v1>=V || v2>=V || v3>=V) Error(dre);

	    x1=X1[i]=X[v1]; y1=Y1[i]=Y[v1]; z1=Z1[i]=Z[v1];
	    x2=X2[i]=X[v2]; y2=Y2[i]=Y[v2]; z2=Z2[i]=Z[v2];
	    x3=X3[i]=X[v3]; y3=Y3[i]=Y[v3]; z3=Z3[i]=Z[v3];
	    v+=(w=x1*y2*z3+x2*y3*z1+x3*y1*z2-x3*y2*z1-x1*y3*z2-x2*y1*z3);
	    x+=(w*(x1+x2+x3)); y+=(w*(y1+y2+y3)); z+=(w*(z1+z2+z3));
	}
	if (file!=stdin) (void)fclose(file);

	w=v*4.0;
	(void)printf("%lf\t%lf\t%lf\t%lf\t",v/6.0,x/=w,y/=w,z/=w);

	SurfaceIntegral(1,F,&x,&y,&z,X1,Y1,Z1,X2,Y2,Z2,X3,Y3,Z3,&w,&x,&y,&z);
	(void)printf("%lf\t%lf\t%lf\t%lf\n",w,x,y,z);

	if (argc==2)
	    N=V;
	else {
	    if (argv[2][0]=='-')
		if (argv[2][1]=='-') {
		    if (argv[2][2]=='-')
			for (i=0; i<V; i++) (void)putchar('\n');

		    if (RA(X,F) || RA(Y,F) || RA(Z,F)) Error(mrae);

		    for (N=0; N<F; N++) {
			X[N]=(X1[N]+X2[N]+X3[N])/3.0;
			Y[N]=(Y1[N]+Y2[N]+Y3[N])/3.0;
			Z[N]=(Z1[N]+Z2[N]+Z3[N])/3.0;
		    }
		    goto Break;
		}
		else
		    file=stdin;
	    else
		if ((file=fopen(argv[2],"r"))==NULL) {
		    (void)fputs(argv[2],stderr); Error(fnf);
		}

	    N=0;
	    while (fgets(str,LEN,file)!=NULL && str[strlen(str)-1]=='\n' &&
		   sscanf(str,"%lf %lf %lf",&x,&y,&z)==3) {
		if (V==N) {
		    V+=INC; if (RA(X,V) || RA(Y,V) || RA(Z,V)) Error(mrae);
		}
		X[N]=x; Y[N]=y; Z[N]=z; ++N;
	    }
	    if (N==0) Error("no point data.");

	    if (N!=V && (RA(X,N) || RA(Y,N) || RA(Z,N))) Error(mrae);

	    if (file!=stdin) (void)fclose(file);
	}
Break:;
	if (MA(P,N)) Error(mae);

	SurfaceIntegral(N,F,X,Y,Z,X1,Y1,Z1,X2,Y2,Z2,X3,Y3,Z3,P,X,Y,Z);

	for (i=0; i<N; i++) {
	    (void)printf("%lf\t%lf\t%lf\t%lf\n",P[i],X[i],Y[i],Z[i]);

	    if (i==0) {
		p1=p2=P[0]; x1=x2=X[0]; y1=y2=Y[0]; z1=z2=Z[0];
	    }
	    else {
		if (p1>P[i]) p1=P[i]; else if (p2<P[i]) p2=P[i];
		if (x1>X[i]) x1=X[i]; else if (x2<X[i]) x2=X[i];
		if (y1>Y[i]) y1=Y[i]; else if (y2<Y[i]) y2=Y[i];
		if (z1>Z[i]) z1=Z[i]; else if (z2<Z[i]) z2=Z[i];
	    }
	}
	(void)fprintf(stderr,"%lf\t%lf\n"
			     "%lf\t%lf\n"
			     "%lf\t%lf\n"
			     "%lf\t%lf\n",p1,p2,x1,x2,y1,y2,z1,z2);

	return 0;
}
