
#include <stdlib.h>

#ifdef	_WIN32
#include <process.h>
#include <windows.h>

#define THREAD_TYPE	HANDLE
#define FUNCTION_TYPE	unsigned __stdcall
#define RETURN_VALUE	0

#define INIT_THREAD(THREAD,FUNCTION,ARGUMENT)	\
	(THREAD=(HANDLE) \
		_beginthreadex(NULL,0,FUNCTION,(void *)ARGUMENT,0,NULL))==0

#define TERM_THREAD(THREAD)	\
	WaitForSingleObject(THREAD,INFINITE)==WAIT_FAILED || \
	CloseHandle(THREAD)==0
#else
#include <pthread.h>

#define THREAD_TYPE	pthread_t
#define FUNCTION_TYPE	void *
#define RETURN_VALUE	NULL

#define INIT_THREAD(THREAD,FUNCTION,ARGUMENT)	\
	pthread_create(&(THREAD),NULL,FUNCTION,(void *)ARGUMENT)

#define TERM_THREAD(THREAD)	pthread_join(THREAD,NULL)
#endif

extern void	Error(char *msg);

static int	BeginMT(THREAD_TYPE **T)
{
	char	*e;
	int	M=1;

	if ((e=getenv("THREADS"))!=NULL &&
	    (M=atoi(e))<=0) Error("bad number of THREADS.");

	if ((*T=(THREAD_TYPE *)malloc(sizeof(THREAD_TYPE)*M))==NULL)
	    Error("memory allocation error for multi-threading.");

	return M;
}

#define EndMT(T)	free(T)
