
#ifndef	VALUE
#error macro VALUE is not defined.
#endif

#include <stdio.h>
#include <math.h>
#include "facet.h"

#define UShort	unsigned short

extern void	Error(char *msg),
		CM_STL(char *path,UShort *flag),
		SurfaceIntegral(double x0,double y0,double z0,
				double x1,double y1,double z1,
				double x2,double y2,double z2,
				double x3,double y3,double z3,
				double *P,double *X,double *Y,double *Z);

int	main(int argc,char **argv)
{
	size_t	N,m,l,n;
	Facet	*facet;
	UShort  flag[32768];
	double	DV1,DV2,x,y,z,P,X,Y,Z,xa,ya,za,xb,yb,zb,c,DV,min,max,base,step;

	if (argc!=2 && argc!=4 && argc!=6)
	    Error("usage : stl_dv STL\n"
		  "        stl_dv STL CM_STL STL\n"
		  "        stl_dv STL min. max. CM_STL STL");

	ReadFacet(argv[1],&N,&facet);

	if (argc!=2) CM_STL(argv[argc-2],flag);

	if (argc==6)
	    if ((DV1=atof(argv[2])*M_PI/180.0)<0.0 ||
		(DV2=atof(argv[3])*M_PI/180.0)>M_PI || DV1>DV2)
		Error("bad range of deviation of the vertical in degree.");

#define X1(n)	facet[n].x1
#define Y1(n)	facet[n].y1
#define Z1(n)	facet[n].z1
#define X2(n)	facet[n].x2
#define Y2(n)	facet[n].y2
#define Z2(n)	facet[n].z2
#define X3(n)	facet[n].x3
#define Y3(n)	facet[n].y3
#define Z3(n)	facet[n].z3

	for (m=0; m<N; m++) {
	    x=(X1(m)+X2(m)+X3(m))/3.0;
	    y=(Y1(m)+Y2(m)+Y3(m))/3.0;
	    z=(Z1(m)+Z2(m)+Z3(m))/3.0; P=X=Y=Z=0.0;
	    for (l=0; l<N; l++)
		SurfaceIntegral(x,y,z,X1(l),Y1(l),Z1(l),
				      X2(l),Y2(l),Z2(l),
				      X3(l),Y3(l),Z3(l),&P,&X,&Y,&Z);

	    xa=X2(m)-X1(m); ya=Y2(m)-Y1(m); za=Z2(m)-Z1(m);
	    xb=X3(m)-X1(m); yb=Y3(m)-Y1(m); zb=Z3(m)-Z1(m);
	    c=X*(x=ya*zb-za*yb)+Y*(y=za*xb-xa*zb)+Z*(z=xa*yb-ya*xb);
	    facet[m].VALUE=DV=atan2(sqrt((X*X+Y*Y+Z*Z)*(x*x+y*y+z*z)-c*c),-c);
	    if (m==0)
		min=max=DV;
	    else
		if (DV<min) min=DV; else if (DV>max) max=DV;
	}
	if (argc==2)
	    (void)printf("%lf\t%lf\n",min*180.0/M_PI,max*180.0/M_PI);
	else {
	    if (argc==4) {
		DV1=min; DV2=max;
	    }
	    base=DV1; step=(DV2-DV1)/32767.0;
	    for (n=0; n<N; n++)
		facet[n].FLAG=flag[(facet[n].VALUE<=DV1)?0:
				   (facet[n].VALUE>=DV2)?32767:
				   (UShort)((facet[n].VALUE-base)/step+0.5)];

	    StoreFacet(argv[argc-1],N,facet);
	}
	return 0;
}
