
#ifndef	VALUE
#error macro VALUE is not defined.
#endif

#include <stdio.h>

#define SI_G
#include "si.h"

#include "mt.h"

#define UShort	unsigned short

extern void	CM_STL(char *path,UShort *flag);

static size_t	M,N;
static Facet	*facet;
static SI	*si;

static FUNCTION_TYPE	ExecuteSI(void *arg)
{
	size_t	n;
	double	X,Y,Z,c;

	for (n=(size_t)arg; n<N; n+=M) {
	    CalculateSI(N,facet,si,(X1(n)+X2(n)+X3(n))/3.0,
				   (Y1(n)+Y2(n)+Y3(n))/3.0,
				   (Z1(n)+Z2(n)+Z3(n))/3.0,&X,&Y,&Z);

	    c=X*si[n].nx+Y*si[n].ny+Z*si[n].nz;
	    facet[n].VALUE=atan2(sqrt(X*X+Y*Y+Z*Z-c*c),-c);
	}
	return RETURN_VALUE;
}

int	main(int argc,char **argv)
{
	THREAD_TYPE	*T;
	UShort		flag[32768];
	double		DV1,DV2,min,max,base,step;
	size_t		m,n;

	if (argc!=2 && argc!=4 && argc!=6)
	    Error("usage : stl_dv STL\n"
		  "        stl_dv STL CM_STL STL\n"
		  "        stl_dv STL min. max. CM_STL STL");

	M=(size_t)BeginMT(&T);

	ReadFacet(argv[1],&N,&facet);

	if (argc!=2) CM_STL(argv[argc-2],flag);

	if (argc==6)
	    if ((DV1=atof(argv[2])*M_PI/180.0)<0.0 ||
		(DV2=atof(argv[3])*M_PI/180.0)>M_PI || DV1>DV2)
		Error("bad range of deviation of the vertical in degree.");

	si=BeginSI(N,facet);

	for (m=1; m<M; m++)
	    if (INIT_THREAD(T[m],ExecuteSI,(size_t)m))
		Error("multi-threading initialization error.");

	(void)ExecuteSI(0);

	for (m=M-1; m>=1; m--)
	    if (TERM_THREAD(T[m])) Error("multi-threading termination error.");

	EndSI(si); EndMT(T);

	min=max=facet->VALUE;
	for (n=1; n<N; n++)
	    if (facet[n].VALUE<min) min=facet[n].VALUE; else
	    if (facet[n].VALUE>max) max=facet[n].VALUE;

	if (argc==2)
	    (void)printf("%lf\t%lf\n",min*180.0/M_PI,max*180.0/M_PI);
	else {
	    if (argc==4) {
		DV1=min; DV2=max;
	    }
	    base=DV1; step=(DV2-DV1)/32767.0;
	    for (n=0; n<N; n++)
		facet[n].FLAG=flag[(facet[n].VALUE<=DV1)?0:
				   (facet[n].VALUE>=DV2)?32767:
				   (UShort)((facet[n].VALUE-base)/step+0.5)];

	    StoreFacet(argv[argc-1],N,facet);
	}
	return 0;
}
