
#ifndef	VALUE
#error macro VALUE is not defined.
#endif

#include <stdio.h>

#define SI_G
#include "si.h"

#define UShort	unsigned short

extern void	CM_STL(char *path,UShort *flag);

int	main(int argc,char **argv)
{
	size_t	N,n;
	Facet	*facet;
	UShort  flag[32768];
	double	DV1,DV2,X,Y,Z,c,DV,min,max,base,step;
	SI	*si;

	if (argc!=2 && argc!=4 && argc!=6)
	    Error("usage : stl_dv STL\n"
		  "        stl_dv STL CM_STL STL\n"
		  "        stl_dv STL min. max. CM_STL STL");

	ReadFacet(argv[1],&N,&facet);

	if (argc!=2) CM_STL(argv[argc-2],flag);

	if (argc==6)
	    if ((DV1=atof(argv[2])*M_PI/180.0)<0.0 ||
		(DV2=atof(argv[3])*M_PI/180.0)>M_PI || DV1>DV2)
		Error("bad range of deviation of the vertical in degree.");

	si=BeginSI(N,facet);

	for (n=0; n<N; n++) {
	    CalculateSI(N,facet,si,(X1(n)+X2(n)+X3(n))/3.0,
				   (Y1(n)+Y2(n)+Y3(n))/3.0,
				   (Z1(n)+Z2(n)+Z3(n))/3.0,&X,&Y,&Z);

	    c=X*si[n].nx+Y*si[n].ny+Z*si[n].nz;
	    facet[n].VALUE=DV=atan2(sqrt(X*X+Y*Y+Z*Z-c*c),-c);
	    if (n==0)
		min=max=DV;
	    else
		if (DV<min) min=DV; else if (DV>max) max=DV;
	}
	EndSI(si);

	if (argc==2)
	    (void)printf("%lf\t%lf\n",min*180.0/M_PI,max*180.0/M_PI);
	else {
	    if (argc==4) {
		DV1=min; DV2=max;
	    }
	    base=DV1; step=(DV2-DV1)/32767.0;
	    for (n=0; n<N; n++)
		facet[n].FLAG=flag[(facet[n].VALUE<=DV1)?0:
				   (facet[n].VALUE>=DV2)?32767:
				   (UShort)((facet[n].VALUE-base)/step+0.5)];

	    StoreFacet(argv[argc-1],N,facet);
	}
	return 0;
}
