
#ifndef	VALUE
#error macro VALUE is not defined.
#endif

#include <stdio.h>
#include "facet.h"

#define UShort	unsigned short

extern void	Error(char *msg),
		CM_STL(char *path,UShort *flag),
		SurfaceIntegral(double x0,double y0,double z0,
				double x1,double y1,double z1,
				double x2,double y2,double z2,
				double x3,double y3,double z3,
				double *P,double *X,double *Y,double *Z);

int	main(int argc,char **argv)
{
	size_t	N,n,m,l;
	Facet	*facet;
	UShort	flag[32768];
	double	P1,P2,V,x,y,z,v,P0,X,Y,Z,P,min,max,base,step;

	if (argc!=2 && argc!=4 && argc!=6)
	    Error("usage : stl_np STL\n"
		  "        stl_np STL CM_STL STL\n"
		  "        stl_np STL min. max. CM_STL STL");

	ReadFacet(argv[1],&N,&facet);

	if (argc!=2) CM_STL(argv[argc-2],flag);

	if (argc==6)
	    if ((P1=atof(argv[2]))>=
		(P2=atof(argv[3]))) Error("bad range of normalized potential.");

#define X1(n)	facet[n].x1
#define Y1(n)	facet[n].y1
#define Z1(n)	facet[n].z1
#define X2(n)	facet[n].x2
#define Y2(n)	facet[n].y2
#define Z2(n)	facet[n].z2
#define X3(n)	facet[n].x3
#define Y3(n)	facet[n].y3
#define Z3(n)	facet[n].z3

	V=x=y=z=0.0;
	for (n=0; n<N; n++) {
	    V+=(v=X1(n)*Y2(n)*Z3(n)+X2(n)*Y3(n)*Z1(n)+X3(n)*Y1(n)*Z2(n)
		 -X3(n)*Y2(n)*Z1(n)-X1(n)*Y3(n)*Z2(n)-X2(n)*Y1(n)*Z3(n));
	    x+=(v*(X1(n)+X2(n)+X3(n)));
	    y+=(v*(Y1(n)+Y2(n)+Y3(n)));
	    z+=(v*(Z1(n)+Z2(n)+Z3(n)));
        }
	x/=(V*4.0); y/=(V*4.0); z/=(V*4.0);

	P0=X=Y=Z=0.0;
	for (n=0; n<N; n++)
	    SurfaceIntegral(x,y,z,X1(n),Y1(n),Z1(n),
				  X2(n),Y2(n),Z2(n),
				  X3(n),Y3(n),Z3(n),&P0,&X,&Y,&Z);

	for (m=0; m<N; m++) {
	    x=(X1(m)+X2(m)+X3(m))/3.0;
	    y=(Y1(m)+Y2(m)+Y3(m))/3.0;
	    z=(Z1(m)+Z2(m)+Z3(m))/3.0; P=X=Y=Z=0.0;
	    for (l=0; l<N; l++)
		SurfaceIntegral(x,y,z,X1(l),Y1(l),Z1(l),
				      X2(l),Y2(l),Z2(l),
				      X3(l),Y3(l),Z3(l),&P,&X,&Y,&Z);

	    facet[m].VALUE=(P/=P0);
	    if (m==0)
		min=max=P;
	    else
		if (P<min) min=P; else if (P>max) max=P;
	}
	if (argc==2)
	    (void)printf("%le\t%lf\t%lf\n",P0,min,max);
	else {
	    if (argc==4) {
		P1=min; P2=max;
	    }
	    base=P1; step=(P2-P1)/32767.0;
	    for (n=0; n<N; n++)
		facet[n].FLAG=flag[(facet[n].VALUE<=P1)?0:
				   (facet[n].VALUE>=P2)?32767:
				   (UShort)((facet[n].VALUE-base)/step+0.5)];

	    StoreFacet(argv[argc-1],N,facet);
	}
	return 0;
}
