
#ifndef	VALUE
#error macro VALUE is not defined.
#endif

#include <stdio.h>

#define SI_P
#include "si.h"

#include "mt.h"

#define UShort	unsigned short

extern void	CM_STL(char *path,UShort *flag);

static size_t	M,N;
static Facet	*facet;
static SI	*si;
static double	P0;

static FUNCTION_TYPE	ExecuteSI(void *arg)
{
	size_t	n;
	double	P;

	for (n=(size_t)arg; n<N; n+=M) {
	    CalculateSI(N,facet,si,(X1(n)+X2(n)+X3(n))/3.0,
				   (Y1(n)+Y2(n)+Y3(n))/3.0,
				   (Z1(n)+Z2(n)+Z3(n))/3.0,&P);

	    facet[n].VALUE=P/P0;
	}
	return RETURN_VALUE;
}

int	main(int argc,char **argv)
{
	THREAD_TYPE	*T;
	size_t		n,m;
	UShort		flag[32768];
	double		P1,P2,V,x,y,z,v,min,max,base,step;

	if (argc!=2 && argc!=4 && argc!=6)
	    Error("usage : stl_np STL\n"
		  "        stl_np STL CM_STL STL\n"
		  "        stl_np STL min. max. CM_STL STL");

	M=(size_t)BeginMT(&T);

	ReadFacet(argv[1],&N,&facet);

	if (argc!=2) CM_STL(argv[argc-2],flag);

	if (argc==6)
	    if ((P1=atof(argv[2]))>=
		(P2=atof(argv[3]))) Error("bad range of normalized potential.");

	si=BeginSI(N,facet);

	V=x=y=z=0.0;
	for (n=0; n<N; n++) {
	    V+=(v=X1(n)*Y2(n)*Z3(n)+X2(n)*Y3(n)*Z1(n)+X3(n)*Y1(n)*Z2(n)
		 -X3(n)*Y2(n)*Z1(n)-X1(n)*Y3(n)*Z2(n)-X2(n)*Y1(n)*Z3(n));
	    x+=(v*(X1(n)+X2(n)+X3(n)));
	    y+=(v*(Y1(n)+Y2(n)+Y3(n)));
	    z+=(v*(Z1(n)+Z2(n)+Z3(n)));
        }
	CalculateSI(N,facet,si,x/(V*4.0),y/(V*4.0),z/(V*4.0),&P0);

	for (m=1; m<M; m++)
	    if (INIT_THREAD(T[m],ExecuteSI,(size_t)m))
		Error("multi-threading initialization error.");

	(void)ExecuteSI(0);

	for (m=M-1; m>=1; m--)
	    if (TERM_THREAD(T[m])) Error("multi-threading termination error.");

	EndSI(si); EndMT(T);

	min=max=facet->VALUE;
	for (n=1; n<N; n++)
	    if (facet[n].VALUE<min) min=facet[n].VALUE; else
	    if (facet[n].VALUE>max) max=facet[n].VALUE;

	if (argc==2)
	    (void)printf("%le\t%lf\t%lf\n",P0,min,max);
	else {
	    if (argc==4) {
		P1=min; P2=max;
	    }
	    base=P1; step=(P2-P1)/32767.0;
	    for (n=0; n<N; n++)
		facet[n].FLAG=flag[(facet[n].VALUE<=P1)?0:
				   (facet[n].VALUE>=P2)?32767:
				   (UShort)((facet[n].VALUE-base)/step+0.5)];

	    StoreFacet(argv[argc-1],N,facet);
	}
	return 0;
}
