
#include <stdio.h>

#define SI_P
#define SI_G
#include "si.h"

#include "mt.h"

static size_t	M,N;
static Facet	*facet;
static SI	*si;
static double	*P,*X,*Y,*Z;

static FUNCTION_TYPE	ExecuteSI(void *arg)
{
	size_t	n;

	for (n=(size_t)arg; n<N; n+=M)
	    CalculateSI(N,facet,si,(X1(n)+X2(n)+X3(n))/3.0,
				   (Y1(n)+Y2(n)+Y3(n))/3.0,
				   (Z1(n)+Z2(n)+Z3(n))/3.0,P+n,X+n,Y+n,Z+n);

	return RETURN_VALUE;
}

int	main(int argc,char **argv)
{
	THREAD_TYPE	*T;
	size_t		n,m;
	double		V,x,y,z,v;

	if (argc!=2) Error("usage : stl_pg STL");

	M=(size_t)BeginMT(&T);

	ReadFacet(argv[1],&N,&facet);

	si=BeginSI(N,facet);

	if ((P=(double *)malloc(sizeof(double)*N))==NULL ||
	    (X=(double *)malloc(sizeof(double)*N))==NULL ||
	    (Y=(double *)malloc(sizeof(double)*N))==NULL ||
	    (Z=(double *)malloc(sizeof(double)*N))==NULL)
	    Error("memory allocation error for P, X, Y and Z.");

	V=x=y=z=0.0;
	for (n=0; n<N; n++) {
	    V+=(v=X1(n)*Y2(n)*Z3(n)+X2(n)*Y3(n)*Z1(n)+X3(n)*Y1(n)*Z2(n)
		 -X3(n)*Y2(n)*Z1(n)-X1(n)*Y3(n)*Z2(n)-X2(n)*Y1(n)*Z3(n));
	    x+=(v*(X1(n)+X2(n)+X3(n)));
	    y+=(v*(Y1(n)+Y2(n)+Y3(n)));
	    z+=(v*(Z1(n)+Z2(n)+Z3(n)));
	}
	v=V*4.0; (void)printf("%le\t%le\t%le\t%le\n",V/6.0,x/=v,y/=v,z/=v);

	CalculateSI(N,facet,si,x,y,z,P,X,Y,Z);

	(void)printf("%le\t%le\t%le\t%le\n",*P,*X,*Y,*Z);

	for (m=1; m<M; m++)
	    if (INIT_THREAD(T[m],ExecuteSI,(size_t)m))
		Error("multi-threading initialization error.");

	(void)ExecuteSI(0);

	for (m=M-1; m>=1; m--)
	    if (TERM_THREAD(T[m])) Error("multi-threading termination error.");

	EndSI(si); EndMT(T);

	for (n=0; n<N; n++)
	    (void)printf("%le\t%le\t%le\t"
			 "%le\t%le\t%le\t"
			 "%le\t%le\t%le\t%le\t%le\t%le\t%le\n",
			 X1(n),Y1(n),Z1(n),
			 X2(n),Y2(n),Z2(n),
			 X3(n),Y3(n),Z3(n),P[n],X[n],Y[n],Z[n]);

	return 0;
}
