
#include <stdio.h>

#define SI_P
#define SI_G
#include "si.h"

int	main(int argc,char **argv)
{
	size_t	N,n;
	Facet	*facet;
	SI	*si;
	double	V,x,y,z,v,P,X,Y,Z;

	if (argc!=2) Error("usage : stl_pg STL");

	ReadFacet(argv[1],&N,&facet);

	si=BeginSI(N,facet);

	V=x=y=z=0.0;
	for (n=0; n<N; n++) {
	    V+=(v=X1(n)*Y2(n)*Z3(n)+X2(n)*Y3(n)*Z1(n)+X3(n)*Y1(n)*Z2(n)
		 -X3(n)*Y2(n)*Z1(n)-X1(n)*Y3(n)*Z2(n)-X2(n)*Y1(n)*Z3(n));
	    x+=(v*(X1(n)+X2(n)+X3(n)));
	    y+=(v*(Y1(n)+Y2(n)+Y3(n)));
	    z+=(v*(Z1(n)+Z2(n)+Z3(n)));
	}
	v=V*4.0; (void)printf("%le\t%le\t%le\t%le\n",V/6.0,x/=v,y/=v,z/=v);

	CalculateSI(N,facet,si,x,y,z,&P,&X,&Y,&Z);

	(void)printf("%le\t%le\t%le\t%le\n",P,X,Y,Z);

	for (n=0; n<N; n++) {
	    CalculateSI(N,facet,si,(X1(n)+X2(n)+X3(n))/3.0,
				   (Y1(n)+Y2(n)+Y3(n))/3.0,
				   (Z1(n)+Z2(n)+Z3(n))/3.0,&P,&X,&Y,&Z);

	    (void)printf("%le\t%le\t%le\t"
			 "%le\t%le\t%le\t"
			 "%le\t%le\t%le\t%le\t%le\t%le\t%le\n",
			 X1(n),Y1(n),Z1(n),
			 X2(n),Y2(n),Z2(n),
			 X3(n),Y3(n),Z3(n),P,X,Y,Z);
	}
	EndSI(si); return 0;
}
