
#include <stdio.h>

#define SI_P
#define SI_G
#include "si.h"

#define LEN	1024

int	main(int argc,char **argv)
{
	size_t	N,n;
	Facet	*facet;
	SI	*si;
	double	V,x,y,z,v,P,X,Y,Z;
	FILE	*file;
	char	text[LEN];

	if (argc!=2 && argc!=3) Error("usage : stl_pxyz STL {point}");

	ReadFacet(argv[1],&N,&facet);

	si=BeginSI(N,facet);

	V=x=y=z=0.0;
	for (n=0; n<N; n++) {
	    V+=(v=X1(n)*Y2(n)*Z3(n)+X2(n)*Y3(n)*Z1(n)+X3(n)*Y1(n)*Z2(n)
		 -X3(n)*Y2(n)*Z1(n)-X1(n)*Y3(n)*Z2(n)-X2(n)*Y1(n)*Z3(n));
	    x+=(v*(X1(n)+X2(n)+X3(n)));
	    y+=(v*(Y1(n)+Y2(n)+Y3(n)));
	    z+=(v*(Z1(n)+Z2(n)+Z3(n)));
	}
	v=V*4.0; (void)printf("%le\t%le\t%le\t%le\n",V/6.0,x/v,y/v,z/v);

	if (argc==2)
	    for (n=0; n<N; n++) {
		CalculateSI(N,facet,si,(X1(n)+X2(n)+X3(n))/3.0,
				       (Y1(n)+Y2(n)+Y3(n))/3.0,
				       (Z1(n)+Z2(n)+Z3(n))/3.0,&P,&X,&Y,&Z);

		(void)printf("%le\t%le\t%le\t"
			     "%le\t%le\t%le\t"
			     "%le\t%le\t%le\t%le\t%le\t%le\t%le\n",
			     X1(n),Y1(n),Z1(n),
			     X2(n),Y2(n),Z2(n),
			     X3(n),Y3(n),Z3(n),P,X,Y,Z);
	    }
	else {
	    if (argv[2][0]=='-')
		file=stdin;
	    else
		if ((file=fopen(argv[2],"r"))==NULL)
		    Error("point file not found.");

	    while (fgets(text,LEN,file)!=NULL &&
		   sscanf(text,"%lf %lf %lf",&x,&y,&z)==3) {
		CalculateSI(N,facet,si,x,y,z,&P,&X,&Y,&Z);

		(void)printf("%le\t%le\t%le\t%le\t%le\t%le\t%le\n",
			     x,y,z,P,X,Y,Z);
	    }
	    if (file!=stdin) (void)fclose(file);
	}
	EndSI(si); return 0;
}
