
#ifdef	VALUE
#error macro VALUE is defined.
#endif
#ifndef	FLAG
#error macro FLAG is not defined.
#endif

#include <stdio.h>
#include <stdlib.h>
#include "facet.h"

#define UShort	unsigned short

extern void	Error(char *msg);

#define LEN	1024

int	main(int argc,char **argv)
{
	size_t	N,n;
	Facet	*facet;
	UShort	flag;
	FILE	*file;
	char	text[LEN],
		RGB[3][LEN],
		*bv="bad R, G and/or B value.";
	double	R,G,B;

	if (argc!=2 && argc!=3 && argc!=4 && argc!=6)
	    Error("usage : stl_rgb STL\n"
		  "        stl_rgb STL STL\n"
		  "        stl_rgb STL RGB STL\n"
		  "        stl_rgb STL R G B STL");

	ReadFacet(argv[1],&N,&facet);

switch(argc) {
    case 2:
	for (n=0; n<N; n++)
	    if ((flag=facet[n].FLAG)&32768)
		(void)printf("%d\t%d\t%d\n",
			     (int)((double)((flag>>10)&31)*255.0/31.0+0.5),
			     (int)((double)((flag>> 5)&31)*255.0/31.0+0.5),
			     (int)((double)( flag     &31)*255.0/31.0+0.5));
	    else
		(void)putchar('\n');

	break;
    case 3:
	for (n=0; n<N; n++) facet[n].FLAG=0;

	StoreFacet(argv[2],N,facet); break;
    case 4:
	if (argv[2][0]=='-')
	    file=stdin;
	else
	    if ((file=fopen(argv[2],"r"))==NULL) Error("RGB file not found.");

	for (n=0; n<N; n++) {
	    if (fgets(text,LEN,file)==NULL) Error("RGB data read error.");

switch(sscanf(text,"%s %s %s",RGB[0],RGB[1],RGB[2])) {
    case 1:
	if (sscanf(*RGB,"%hu",&flag)!=1 || flag>31767) Error("bad flag value.");

	facet[n].FLAG=(UShort)flag; break;
    case 3:
	if (sscanf(RGB[0],"%lf",&R)!=1 || R<0.0 || R>255.0 ||
	    sscanf(RGB[1],"%lf",&G)!=1 || G<0.0 || G>255.0 ||
	    sscanf(RGB[2],"%lf",&B)!=1 || B<0.0 || B>255.0) Error(bv);

	facet[n].FLAG=32768|((UShort)(R*31.0/255.0+0.5)<<10)|
			    ((UShort)(G*31.0/255.0+0.5)<< 5)|
			     (UShort)(B*31.0/255.0+0.5     ); break;
    default:
	facet[n].FLAG=0; break;
}
	}
	if (file!=stdin) (void)fclose(file);

	StoreFacet(argv[3],N,facet); break;
    case 6:
	if ((R=atof(argv[2]))<0.0 || R>255.0 ||
	    (G=atof(argv[3]))<0.0 || G>255.0 ||
	    (B=atof(argv[4]))<0.0 || B>255.0) Error(bv);

	flag=32768|((UShort)(R*31.0/255.0+0.5)<<10)|
		   ((UShort)(G*31.0/255.0+0.5)<< 5)|
		    (UShort)(B*31.0/255.0+0.5     );
	for (n=0; n<N; n++) facet[n].FLAG=flag;

	StoreFacet(argv[5],N,facet); break;
}
	return 0;
}
