
#include <stdio.h>
#include "facet.h"

#define UInt	unsigned int
#define UChar	unsigned char
#define UShort	unsigned short

extern void	Error(char *msg);

static size_t	Fwrite(const void *ptr,size_t size,size_t memb,FILE *file)
{
	UChar	*p=(UChar *)ptr;
	int	m,s;

	for (m=0; m<memb; m++) {
	    p+=size;
	    for (s=1; s<=size; s++)
		if (fputc((int)p[-s],file)==EOF) return (size_t)m;
	}
	return (size_t)m;
}

void	StoreFacet(char *path,size_t N,Facet *facet)
{
	FILE	*file;
	int	i;
	UInt	n=(UInt)N;
	char	*fdwe="facet data write error.";
	float	xa,ya,za,xb,yb,zb,nx,ny,nz;

	UShort	us=255;
	UChar	*uc=(UChar *)&us;
	size_t	(*fWrite)()=(size_t (*)())((*uc==us)?fwrite:Fwrite);

#ifdef	FLAG
#define Flag	(facet->FLAG)
#else
	UShort	Flag=0;
#endif

	if (*path=='-')
	    file=stdout;
	else
	    if ((file=fopen(path,"wb"))==NULL) Error("STL file not stored.");

	for (i=0; i<80; i++) if (fputc(0,file)==EOF) Error(fdwe);

	if (fWrite(&n,4,1,file)!=1) Error(fdwe);

	while (N>0) {
	    xa=facet->x2-facet->x1; xb=facet->x3-facet->x1;
	    ya=facet->y2-facet->y1; yb=facet->y3-facet->y1;
	    za=facet->z2-facet->z1; zb=facet->z3-facet->z1;
	    nx=ya*zb-za*yb; ny=za*xb-xa*zb; nz=xa*yb-ya*xb;
	    if ((*fWrite)(&nx,4,1,file)!=1 ||
		(*fWrite)(&ny,4,1,file)!=1 ||
		(*fWrite)(&nz,4,1,file)!=1 ||
		(*fWrite)(&(facet->x1),4,1,file)!=1 ||
		(*fWrite)(&(facet->y1),4,1,file)!=1 ||
		(*fWrite)(&(facet->z1),4,1,file)!=1 ||
		(*fWrite)(&(facet->x2),4,1,file)!=1 ||
		(*fWrite)(&(facet->y2),4,1,file)!=1 ||
		(*fWrite)(&(facet->z2),4,1,file)!=1 ||
		(*fWrite)(&(facet->x3),4,1,file)!=1 ||
		(*fWrite)(&(facet->y3),4,1,file)!=1 ||
		(*fWrite)(&(facet->z3),4,1,file)!=1 ||
		(*fWrite)(&Flag,2,1,file)!=1) Error(fdwe);

	    ++facet; --N;
	}
	if (file!=stdout) (void)fclose(file);
}
