
#ifdef	VALUE
#error macro VALUE is defined.
#endif
#ifndef	FLAG
#error macro FLAG is not defined.
#endif

#include <stdio.h>
#include <stdlib.h>
#include "facet.h"

#define UShort	unsigned short

extern void	Error(char *msg),
		CM_STL(char *path,UShort *flag);

#define LEN	1024

int	main(int argc,char **argv)
{
	UShort	f,flag[32768];
	char	text[LEN],
		RGB[3][LEN];
	int	i;
	double	x1,y1,z1,x2,y2,z2,x3,y3,z3,R,G,B;
	size_t	n,
		N=0;
	Facet	*facet=NULL;

	if (argc!=2 && argc!=3) Error("usage : t2stl {CM_STL} STL");

	if (argc==2)
	    for (f=0; f<32768; f++) flag[f]=(UShort)(32768|f);
	else
	    CM_STL(argv[1],flag);

	while (fgets(text,LEN,stdin)!=NULL) {
	    if ((i=sscanf(text,"%lf %lf %lf "
			       "%lf %lf %lf "
			       "%lf %lf %lf %s %s %s",
			       &x1,&y1,&z1,
			       &x2,&y2,&z2,
			       &x3,&y3,&z3,RGB[0],RGB[1],RGB[2]))<9)
		Error("missing triangle data.");

	    switch(i) {
		case 10:
		    if (sscanf(*RGB,"%hu",&f)!=1 || f>32767)
			Error("bad flag value.");

		    f=flag[f]; break;
		case 12:
		    if (sscanf(RGB[0],"%lf",&R)!=1 || R<0.0 || R>255.0 ||
			sscanf(RGB[1],"%lf",&G)!=1 || G<0.0 || G>255.0 ||
			sscanf(RGB[2],"%lf",&B)!=1 || B<0.0 || B>255.0)
			Error("bad R, G and/or B value.");

		    f=32768|((UShort)(R*31.0/255.0+0.5)<<10)|
			    ((UShort)(G*31.0/255.0+0.5)<< 5)|
			     (UShort)(B*31.0/255.0+0.5     ); break;
		default:
		    f=0; break;
	    }
	    n=N++;
	    if ((facet=(Facet *)realloc(facet,sizeof(Facet)*N))==NULL)
		Error("facet memory reallocation error.");

	    facet[n].x1=x1; facet[n].y1=y1; facet[n].z1=z1;
	    facet[n].x2=x2; facet[n].y2=y2; facet[n].z2=z2;
	    facet[n].x3=x3; facet[n].y3=y3; facet[n].z3=z3; facet[n].FLAG=f;
	}
	if (N==0) Error("no facet.");

	StoreFacet(argv[argc-1],N,facet);

	return 0;
}
